"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const typescript_1 = __importDefault(require("typescript"));
const Utils = __importStar(require("../../../utils"));
const UtilsExtra = __importStar(require("../utils"));
const create = (factory, params) => {
    const properties = Object.entries(params.object).reduce((previous, [key, item]) => {
        const childProperties = [
            factory.PropertyAssignment.create({
                name: "value",
                initializer: item.type === "variable"
                    ? UtilsExtra.generateVariableIdentifier(factory, item.value)
                    : factory.StringLiteral.create({ text: item.value }),
            }),
        ];
        if (item.style) {
            childProperties.push(factory.PropertyAssignment.create({
                name: "style",
                initializer: factory.StringLiteral.create({ text: item.style }),
            }));
        }
        childProperties.push(factory.PropertyAssignment.create({
            name: "explode",
            initializer: item.explode ? typescript_1.default.factory.createTrue() : typescript_1.default.factory.createFalse(),
        }));
        const childObjectInitializer = factory.ObjectLiteralExpression.create({
            properties: childProperties,
        });
        const childObject = factory.PropertyAssignment.create({
            name: Utils.escapeText(key),
            initializer: childObjectInitializer,
        });
        return previous.concat(childObject);
    }, []);
    return factory.VariableStatement.create({
        declarationList: factory.VariableDeclarationList.create({
            flag: "const",
            declarations: [
                factory.VariableDeclaration.create({
                    name: params.variableName,
                    type: factory.TypeReferenceNode.create({
                        name: "QueryParameters",
                    }),
                    initializer: factory.ObjectLiteralExpression.create({
                        properties,
                        multiLine: true,
                    }),
                }),
            ],
        }),
    });
};
exports.create = create;
//# sourceMappingURL=QueryParameter.js.map