"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = exports.MethodBody = void 0;
const MethodBody = __importStar(require("../../_shared/MethodBody"));
exports.MethodBody = MethodBody;
const generateParams = (factory, { convertedParams }) => {
    const typeArguments = [];
    if (convertedParams.has2OrMoreRequestContentTypes) {
        typeArguments.push(factory.TypeReferenceNode.create({
            name: "RequestContentType",
        }));
    }
    if (convertedParams.has2OrMoreSuccessResponseContentTypes) {
        typeArguments.push(factory.TypeReferenceNode.create({
            name: "ResponseContentType",
        }));
    }
    return factory.ParameterDeclaration.create({
        name: "params",
        modifiers: undefined,
        type: factory.TypeReferenceNode.create({
            name: convertedParams.argumentParamsTypeDeclaration,
            typeArguments,
        }),
    });
};
const generateResponseReturnType = (factory, successResponseNameList, successResponseContentTypeList, option) => {
    let objectType = factory.TypeNode.create({
        type: "void",
    });
    if (successResponseNameList.length === 1) {
        objectType = factory.TypeReferenceNode.create({
            name: successResponseNameList[0],
        });
    }
    else if (successResponseNameList.length > 1) {
        objectType = factory.UnionTypeNode.create({
            typeNodes: successResponseNameList.map(item => factory.TypeReferenceNode.create({ name: item })),
        });
    }
    // レスポンスが存在しないので Promise<void>
    if (successResponseNameList.length === 0) {
        if (option.sync) {
            return objectType;
        }
        return factory.TypeReferenceNode.create({
            name: "Promise",
            typeArguments: [objectType],
        });
    }
    const isOnlyOneResponseContentType = successResponseContentTypeList.length === 1;
    let indexType = factory.TypeReferenceNode.create({
        name: "ResponseContentType",
    });
    if (isOnlyOneResponseContentType) {
        indexType = factory.TypeReferenceNode.create({
            name: `"${successResponseContentTypeList[0]}"`,
        });
    }
    if (option.sync) {
        return factory.IndexedAccessTypeNode.create({
            objectType,
            indexType,
        });
    }
    return factory.TypeReferenceNode.create({
        name: "Promise",
        typeArguments: [
            factory.IndexedAccessTypeNode.create({
                objectType,
                indexType,
            }),
        ],
    });
};
const methodTypeParameters = (factory, { convertedParams }) => {
    const typeParameters = [];
    if (convertedParams.has2OrMoreRequestContentTypes) {
        typeParameters.push(factory.TypeParameterDeclaration.create({
            name: "RequestContentType",
            constraint: factory.TypeReferenceNode.create({
                name: convertedParams.requestContentTypeName,
            }),
        }));
    }
    if (convertedParams.has2OrMoreSuccessResponseContentTypes) {
        typeParameters.push(factory.TypeParameterDeclaration.create({
            name: "ResponseContentType",
            constraint: factory.TypeReferenceNode.create({
                name: convertedParams.responseContentTypeName,
            }),
        }));
    }
    return typeParameters;
};
/**
 * async (params: {argumentParamsTypeDeclaration}<{RequestContentType}>): Promise<{requestBodyName}[ResponseContentType]> => {}
 */
const create = (factory, params, option) => {
    const { convertedParams } = params;
    const typeParameters = methodTypeParameters(factory, params);
    const methodArguments = [];
    const hasParamsArguments = convertedParams.hasParameter ||
        convertedParams.hasRequestBody ||
        convertedParams.has2OrMoreSuccessResponseContentTypes ||
        convertedParams.has2OrMoreRequestContentTypes;
    if (hasParamsArguments) {
        methodArguments.push(generateParams(factory, params));
    }
    const returnType = generateResponseReturnType(factory, convertedParams.responseSuccessNames, convertedParams.successResponseContentTypes, option);
    methodArguments.push(factory.ParameterDeclaration.create({
        name: "option",
        modifiers: undefined,
        optional: true,
        type: factory.TypeReferenceNode.create({
            name: "RequestOption",
        }),
    }));
    return factory.ArrowFunction.create({
        typeParameters: typeParameters,
        parameters: methodArguments,
        type: returnType,
        body: factory.Block.create({
            statements: MethodBody.create(factory, params, "function"),
            multiLine: true,
        }),
    });
};
exports.create = create;
//# sourceMappingURL=ArrowFunction.js.map