"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileSystem = void 0;
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const dot_prop_1 = __importDefault(require("dot-prop"));
const yaml = __importStar(require("js-yaml"));
const Exception_1 = require("../Exception");
class FileSystem {
    static internalLoadJsonOrYaml(filename) {
        const ext = path.extname(filename);
        const data = fs.readFileSync(filename, { encoding: "utf-8" });
        switch (ext) {
            case ".json":
                return JSON.parse(data);
            case ".yml":
            case ".yaml":
                return yaml.load(data);
            default:
                throw new Exception_1.UnSupportError(`Not support file: ${filename}`);
        }
    }
    static existSync(entryPoint) {
        const fragmentIndex = entryPoint.indexOf(this.FRAGMENT);
        const hasFragment = fragmentIndex !== -1;
        if (hasFragment) {
            const filename = entryPoint.substring(0, fragmentIndex);
            return !!(fs.existsSync(filename) && fs.statSync(filename).isFile());
        }
        return !!(fs.existsSync(entryPoint) && fs.statSync(entryPoint).isFile());
    }
    static loadJsonOrYaml(entryPoint) {
        const hasFragment = entryPoint.indexOf(this.FRAGMENT) !== -1;
        if (hasFragment) {
            const [filename, fragment] = entryPoint.split(this.FRAGMENT);
            const data = this.internalLoadJsonOrYaml(filename);
            return dot_prop_1.default.get(data, fragment.replace(/\//g, "."));
        }
        return this.internalLoadJsonOrYaml(entryPoint);
    }
}
exports.FileSystem = FileSystem;
FileSystem.FRAGMENT = "#/";
//# sourceMappingURL=index.js.map