"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateInterface = exports.generatePropertySignatures = exports.generatePropertySignature = exports.generateTypeNode = void 0;
const Guard = __importStar(require("../Guard"));
const ToTypeNode = __importStar(require("../toTypeNode"));
const Reference = __importStar(require("./Reference"));
const generateTypeNode = (entryPoint, currentPoint, factory, name, header, context, converterContext) => {
    return factory.TypeAliasDeclaration.create({
        export: true,
        name: converterContext.escapeDeclarationText(name),
        type: ToTypeNode.convert(entryPoint, currentPoint, factory, header.schema || { type: "null" }, context, converterContext),
    });
};
exports.generateTypeNode = generateTypeNode;
const generatePropertySignature = (entryPoint, currentPoint, factory, name, header, context, converterContext) => {
    if (Guard.isReference(header)) {
        const reference = Reference.generate(entryPoint, currentPoint, header);
        if (reference.type === "local") {
            context.setReferenceHandler(currentPoint, reference);
            return factory.PropertySignature.create({
                readOnly: false,
                name: converterContext.escapePropertySignatureName(name),
                optional: false,
                type: factory.TypeReferenceNode.create({
                    name: context.resolveReferencePath(currentPoint, reference.path).name,
                }),
            });
        }
        return factory.PropertySignature.create({
            readOnly: false,
            name: converterContext.escapePropertySignatureName(name),
            optional: false,
            type: factory.TypeReferenceNode.create({
                name: context.resolveReferencePath(currentPoint, reference.path).name,
            }),
        });
    }
    return factory.PropertySignature.create({
        readOnly: false,
        name: converterContext.escapePropertySignatureName(name),
        optional: false,
        type: ToTypeNode.convert(entryPoint, currentPoint, factory, header.schema || { type: "null" }, context, converterContext),
    });
};
exports.generatePropertySignature = generatePropertySignature;
const generatePropertySignatures = (entryPoint, currentPoint, factory, headers, context, converterContext) => {
    return Object.entries(headers).map(([headerName, header]) => {
        return (0, exports.generatePropertySignature)(entryPoint, currentPoint, factory, headerName, header, context, converterContext);
    });
};
exports.generatePropertySignatures = generatePropertySignatures;
const generateInterface = (entryPoint, currentPoint, factory, name, headers, context, converterContext) => {
    return factory.InterfaceDeclaration.create({
        export: true,
        name: converterContext.escapeDeclarationText(name),
        members: (0, exports.generatePropertySignatures)(entryPoint, currentPoint, factory, headers, context, converterContext),
    });
};
exports.generateInterface = generateInterface;
//# sourceMappingURL=Header.js.map