"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateInterface = exports.generatePropertySignatures = void 0;
const generatePropertySignatures = (_entryPoint, _currentPoint, factory, securitySchema) => {
    const signatures = [
        factory.PropertySignature.create({
            readOnly: false,
            name: "type",
            optional: false,
            type: factory.LiteralTypeNode.create({ value: securitySchema.type }),
        }),
        factory.PropertySignature.create({
            readOnly: false,
            name: "name",
            optional: false,
            type: factory.LiteralTypeNode.create({ value: securitySchema.name }),
        }),
        factory.PropertySignature.create({
            readOnly: false,
            name: "in",
            optional: false,
            type: factory.LiteralTypeNode.create({ value: securitySchema.in }),
        }),
        factory.PropertySignature.create({
            readOnly: false,
            name: "openIdConnectUrl",
            optional: false,
            type: factory.LiteralTypeNode.create({ value: securitySchema.openIdConnectUrl }),
        }),
    ];
    return signatures;
};
exports.generatePropertySignatures = generatePropertySignatures;
const generateInterface = (entryPoint, currentPoint, factory, name, securitySchema) => {
    return factory.InterfaceDeclaration.create({
        export: true,
        name,
        comment: securitySchema.description,
        members: (0, exports.generatePropertySignatures)(entryPoint, currentPoint, factory, securitySchema),
    });
};
exports.generateInterface = generateInterface;
//# sourceMappingURL=SecuritySchema.js.map