"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertIntermediateCodes = exports.stringToStatements = void 0;
const typescript_1 = __importDefault(require("typescript"));
const stringToStatements = (code) => {
    const source = typescript_1.default.createSourceFile("", code, typescript_1.default.ScriptTarget.ESNext, false, typescript_1.default.ScriptKind.TS);
    return Array.from(source.statements);
};
exports.stringToStatements = stringToStatements;
const convertIntermediateCodes = (intermediateCodes) => {
    return intermediateCodes.reduce((result, intermediateCode) => {
        if (typeof intermediateCode === "string") {
            return [...result, ...(0, exports.stringToStatements)(intermediateCode)];
        }
        return result.concat(intermediateCode);
    }, []);
};
exports.convertIntermediateCodes = convertIntermediateCodes;
//# sourceMappingURL=utils.js.map