"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.validate = void 0;
//
// Copyright (c) 2018 Kogo Software LLC
// Reference: https://github.com/kogosoftwarellc/open-api/tree/master/packages/openapi-schema-validator#readme
//
const Ajv = __importStar(require("ajv"));
const openapi_json_1 = __importDefault(require("./openapi.json"));
const showLogs = (logs, logger) => {
    if (logger && logger.displayLogLines && logger.displayLogLines > 0) {
        const latestLogs = logs.slice(0, logger.displayLogLines);
        const moreLogNum = logs.length - latestLogs.length;
        console.error("Correct the validation error before generating the code.");
        console.error(`There are a total of ${logs.length} errors below.`);
        console.error("");
        console.error(latestLogs);
        console.error("");
        if (moreLogNum > 0) {
            console.error(`more ${moreLogNum} error logs`);
            console.error("");
        }
    }
    else {
        console.error("Correct the validation error before generating the code.");
        console.error(`There are a total of ${logs.length} errors below.`);
        console.error("");
        console.error(logs);
        console.error("");
    }
};
const validate = (openapiDoc, logger) => {
    const ajv = new Ajv.default({ allErrors: true });
    const validate = ajv.compile(openapi_json_1.default);
    validate(openapiDoc);
    if (validate.errors) {
        showLogs(validate.errors, logger);
        throw new Error("Validation Error");
    }
};
exports.validate = validate;
//# sourceMappingURL=index.js.map