import { EOL } from "os";
import ts from "typescript";
import * as ArrowFunction from "./CurryingArrowFunction";
export const create = (factory, list, option) => {
    const variableStatements = list.map(params => {
        return factory.VariableStatement.create({
            comment: option.additionalMethodComment
                ? [params.operationParams.comment, `operationId: ${params.operationId}`, `Request URI: ${params.operationParams.requestUri}`]
                    .filter(t => !!t)
                    .join(EOL)
                : params.operationParams.comment,
            modifiers: [ts.factory.createToken(ts.SyntaxKind.ExportKeyword)],
            declarationList: factory.VariableDeclarationList.create({
                declarations: [
                    factory.VariableDeclaration.create({
                        name: params.convertedParams.functionName,
                        initializer: ArrowFunction.create(factory, params, option),
                    }),
                ],
                flag: "const",
            }),
        });
    });
    return variableStatements;
};
//# sourceMappingURL=index.js.map