import { Operator } from "@himenon/path-oriented-data-structure";
import * as DataStructure from "./DataStructure";
import * as InterfaceNode from "./InterfaceNode";
import * as NamespaceTree from "./NamespaceTree";
import * as TypeAliasNode from "./TypeAliasNode";
export { DataStructure, InterfaceNode, NamespaceTree, TypeAliasNode };
export const createInstance = (component) => {
    if (component.kind === "interface") {
        return new InterfaceNode.Item(component);
    }
    if (component.kind === "typeAlias") {
        return new TypeAliasNode.Item(component);
    }
    if (component.kind === "namespace") {
        return new NamespaceTree.Item(component);
    }
    throw new Error("not registers");
};
export const create = () => {
    const operator = new Operator("namespace");
    return {
        operator,
        getChildByPaths: DataStructure.createGetChildByPaths(operator),
    };
};
//# sourceMappingURL=index.js.map