export const generatePropertySignatures = (_entryPoint, _currentPoint, factory, securitySchema) => {
    const signatures = [
        factory.PropertySignature.create({
            readOnly: false,
            name: "type",
            optional: false,
            type: factory.LiteralTypeNode.create({ value: securitySchema.type }),
        }),
        factory.PropertySignature.create({
            readOnly: false,
            name: "name",
            optional: false,
            type: factory.LiteralTypeNode.create({ value: securitySchema.name }),
        }),
        factory.PropertySignature.create({
            readOnly: false,
            name: "in",
            optional: false,
            type: factory.LiteralTypeNode.create({ value: securitySchema.in }),
        }),
        factory.PropertySignature.create({
            readOnly: false,
            name: "openIdConnectUrl",
            optional: false,
            type: factory.LiteralTypeNode.create({ value: securitySchema.openIdConnectUrl }),
        }),
    ];
    return signatures;
};
export const generateInterface = (entryPoint, currentPoint, factory, name, securitySchema) => {
    return factory.InterfaceDeclaration.create({
        export: true,
        name,
        comment: securitySchema.description,
        members: generatePropertySignatures(entryPoint, currentPoint, factory, securitySchema),
    });
};
//# sourceMappingURL=SecuritySchema.js.map