import ts from "typescript";
import { generateComment } from "./utils";
export const create = ({ factory }) => (params) => {
    const node = factory.createPropertyAssignment(params.name, params.initializer);
    if (params.comment) {
        const comment = generateComment(params.comment, params.deprecated);
        return ts.addSyntheticLeadingComment(node, ts.SyntaxKind.MultiLineCommentTrivia, comment.value, comment.hasTrailingNewLine);
    }
    return node;
};
export const make = (context) => {
    return {
        create: create(context),
    };
};
//# sourceMappingURL=PropertyAssignment.js.map