import ts from "typescript";
import type { TsGenerator } from "../../api";
export interface StringItem {
    type: "string";
    value: string;
}
export interface ExpressionItem {
    type: "property";
    value: ts.Expression;
}
export type Item = StringItem | ExpressionItem;
export type Params$TemplateExpression = Item[];
/**
 *
 * ``
 * `a`
 * `${b}`
 * `a${b}`
 * `${a}${b}`
 * `${a}b${c}`
 * ``
 */
export declare const generateTemplateExpression: (factory: TsGenerator.Factory.Type, list: Params$TemplateExpression) => ts.Expression;
export interface VariableAccessIdentifer {
    kind: "string";
    value: string;
}
export interface ElementAccessExpression {
    kind: "element-access";
    value: string;
}
export type VariableElement = VariableAccessIdentifer | ElementAccessExpression;
export declare const splitVariableText: (text: string) => VariableElement[];
export declare const generateVariableIdentifier: (factory: TsGenerator.Factory.Type, name: string) => ts.Identifier | ts.PropertyAccessExpression | ts.ElementAccessExpression;
export interface LiteralExpressionObject {
    [key: string]: {
        type: "string" | "variable";
        value: string;
    };
}
export declare const generateObjectLiteralExpression: (factory: TsGenerator.Factory.Type, obj: LiteralExpressionObject, extraProperties?: ts.PropertyAssignment[]) => ts.ObjectLiteralExpression;
/**
 * "/{a}/b/{a}/c{a}/".split(new RegExp("({a})"))
 * => ["/", "{a}", "/b/", "{a}", "/c", "{a}", "/"]
 */
export declare const stringToArray: (text: string, delimiter: string) => string[];
export declare const multiSplitStringToArray: (text: string, delimiters: string[]) => string[];
